<% Option Explicit %>

<!-- #include file = "SQL.asp" -->

<%

'--HEADER--------------------------------------------------------------------------
'
'    Project   : Live ACARS Demo Web Service v3.1
'    Author    : Thomas Molitor
'    Company   : Thomas Molitor EDV Service
'    Copyright : Copyright  2002-2011 Thomas Molitor
'
'    Notes:
'
'
'
'--END-----------------------------------------------------------------------------

Function GetNewIDFlight(ByVal FlightNumber)
    GetNewIDFlight = Replace(FormatDatetime(Now(), 3), ":","") & FlightNumber
End Function

Dim oConn, oRs
Dim strFunction, strValue, strMessage, strCommand
Dim arData, arPlan
Dim lngCount, i, j, k

'### Added v2.5 ###
Dim m, n, strWP

If Not Connect(oConn) Then
    Response.Write "0|Database connection failed"
    Response.End
End If

'### Added 2.6 ###
'Delete not responding flight entries (LastMessage older than 30 minutes)
oConn.Execute "DELETE FROM LiveACARS WHERE LastMessage <= #" & DateAdd("n", -30, Now()) & "#"

strFunction = UCase(Request("DATA2"))
strValue = Request("DATA3")
strMessage = Request("DATA4")

Select Case strFunction

    Case "BEGINFLIGHT"
        arData = Split(strValue, "|")
        If UBound(arData) < 9 Then
            Response.Write "0|Invalid login data"
        Else
            '### Added v3.0 ###
            Set oRs = Server.CreateObject("ADODB.Recordset")
            oRs.CursorLocation = 3 'adUseClient
            oRs.LockType = 3 'adLockOptimistic
            oRs.CursorType = 1 'adOpenKeyset
            Set oRs.ActiveConnection = oConn
            oRs.Open "SELECT * FROM Pilots WHERE IDPilot = '" & arData(0) & "'", , , , 1 'adCmdText
            
            '### Changed v3.0 ###
            If oRs.EOF Then
                Response.Write "0|Unknown ID " & arData(0)
            Else
                oRs.Close
                
                Set oRs = Server.CreateObject("ADODB.Recordset")
                oRs.CursorLocation = 3 'adUseClient
                oRs.LockType = 3 'adLockOptimistic
                oRs.CursorType = 1 'adOpenKeyset
                Set oRs.ActiveConnection = oConn
                oRs.Open "SELECT * FROM LiveACARS WHERE IDFlight = ''", , , , 1 'adCmdText
                
                oRs.AddNew
                oRs.Fields("IDFlight").Value = GetNewIDFlight(arData(2))
                oRs.Fields("IDPilot").Value = arData(0)
                If Len(arData(1)) <> 0 Then
                    oRs.Fields("PilotName").Value = "Thomas Molitor - " & arData(1)
                Else
                    oRs.Fields("PilotName").Value = "Thomas Molitor"
                End If
                oRs.Fields("Status").Value = 0
                oRs.Fields("Messages").Value = ""
                oRs.Fields("Aircraft").Value = arData(3)
                oRs.Fields("Airline").Value = arData(4)
                oRs.Fields("FlightNumber").Value = arData(2)
                oRs.Fields("FlightPlan").Value = arData(5)
                oRs.Fields("Position").Value = arData(6)
                oRs.Fields("Altitude").Value = arData(7)
                oRs.Fields("IAS").Value = -1
                oRs.Fields("TAS").Value = -1
                oRs.Fields("AltitudeStatus").Value = -1
                oRs.Fields("LastMessage").Value = Now()
                oRs.Fields("Passenger").Value = arData(8)
                oRs.Fields("Cargo").Value = arData(9)

                '### Added v2.5 ###
                oRs.Fields("CurrentWaypoint").Value = ""

                If Len(arData(5)) <> 0 Then
                    arPlan = Split(arData(5), "~")
                    oRs.Fields("OriginAirport").Value = arPlan(0)

                    '### Added v2.5 ###
                    oRs.Fields("CurrentWaypoint").Value = UCase(arPlan(0))

                    If UBound(arPlan) > 0 Then
                        oRs.Fields("DestinationAirport").Value = arPlan(UBound(arPlan))
                    Else
                        oRs.Fields("DestinationAirport").Value = ""
                    End If
                Else
                    oRs.Fields("OriginAirport").Value = ""
                    oRs.Fields("DestinationAirport").Value = ""
                End If
                
                If UBound(arData) >= 10 Then
                    oRs.Fields("ZFW").Value = arData(10)
                    oRs.Fields("Fuel").Value = arData(11)
                    oRs.Fields("Heading").Value = arData(12)
                    oRs.Fields("Wind").Value = arData(13)
                    oRs.Fields("OAT").Value = arData(14)
                    oRs.Fields("FlightType").Value = arData(15)

                    '### Added v2.0 ###
                    oRs.Fields("DistanceFlown").Value = -1
                    oRs.Fields("DistancePlanned").Value = -1

                    If UBound(arData) >= 16 Then
                        oRs.Fields("DistanceFlown").Value = 0
                        oRs.Fields("DistancePlanned").Value = CLng(arData(16))
                    End If

                    '### Added v2.5 ###
                    If UBound(arData) >= 17 Then
                        'Password can be used to verify a login
                        'strPassword = arData(17)
                    End If                  

                    '### Added v2.7 ###
                    If UBound(arData) >= 18 Then
                        oRs.Fields("TrueHeading").Value = arData(18)
                    Else
                        If Len(arData(18)) > 0 Then
                            oRs.Fields("TrueHeading").Value = arData(18)
                        Else
                            oRs.Fields("TrueHeading").Value = -1
                        End If
                    End If                  

                    '### Added v3.0 ###
                    If UBound(arData) >= 20 Then
                        oRs.Fields("FPLatitudes").Value = arData(19)
                        oRs.Fields("FPLongitudes").Value = arData(20)
                    Else
                        oRs.Fields("FPLatitudes").Value = ""
                        oRs.Fields("FPLongitudes").Value = ""
                    End If                  
                Else
                    oRs.Fields("ZFW").Value = -1
                    oRs.Fields("Fuel").Value = -1
                    oRs.Fields("Heading").Value = -1
                    oRs.Fields("Wind").Value = ""
                    oRs.Fields("OAT").Value = -100000
                    oRs.Fields("FlightType").Value = "Not available"

                    '### Added v2.0 ###
                    oRs.Fields("DistanceFlown").Value = -1
                    oRs.Fields("DistancePlanned").Value = -1

                    '### Added v2.7 ###
                    oRs.Fields("TrueHeading").Value = -1
                    
                    '### Added v3.0 ###
                    oRs.Fields("FPLatitudes").Value = ""
                    oRs.Fields("FPLongitudes").Value = ""
                End If
                
                oRs.Fields("PauseMode").Value = False

                oRs.Update

                Response.Write "1|" & oRs.Fields("IDFlight").Value
            End If
        End If

    Case "ENDFLIGHT"
        Set oRs = Server.CreateObject("ADODB.Recordset")
        oRs.CursorLocation = 3 'adUseClient
        oRs.LockType = 3 'adLockOptimistic
        oRs.CursorType = 1 'adOpenKeyset
        Set oRs.ActiveConnection = oConn
        oRs.Open "SELECT * FROM LiveACARS WHERE IDFlight = '" & strValue & "'", , , , 1 'adCmdText      

        If Not oRs.EOF Then
            oRs.Delete
            Response.Write "1"
        Else
            Response.Write "0|Unknown Flight ID"
        End If

    Case "PAUSEFLIGHT"
        Set oRs = Server.CreateObject("ADODB.Recordset")
        oRs.CursorLocation = 3 'adUseClient
        oRs.LockType = 3 'adLockOptimistic
        oRs.CursorType = 1 'adOpenKeyset
        Set oRs.ActiveConnection = oConn
        oRs.Open "SELECT * FROM LiveACARS WHERE IDFlight = '" & strValue & "'", , , , 1 'adCmdText      

        If Not oRs.EOF Then

            If strMessage = "1" Then
                oRs.Fields("PauseMode").Value = True
                oRs.Update
                Response.Write "1"
            ElseIf strMessage = "0" Then
                oRs.Fields("PauseMode").Value = False
                oRs.Update
                Response.Write "1"
            Else
                Response.Write "0|Invalid Pause Mode"
            End If
        Else
            Response.Write "0|Unknown Flight ID"
        End If

    Case "MESSAGE"
        Set oRs = Server.CreateObject("ADODB.Recordset")
        oRs.CursorLocation = 3 'adUseClient
        oRs.LockType = 3 'adLockOptimistic
        oRs.CursorType = 1 'adOpenKeyset
        Set oRs.ActiveConnection = oConn
        oRs.Open "SELECT * FROM LiveACARS WHERE IDFlight = '" & strValue & "'", , , , 1 'adCmdText
        
        If Not oRs.EOF Then         

            j = 0
            k = 0
            j = InStr(1, strMessage, "MESSAGE:" & vbCrLF, 1)
            If j > 0 Then
                j = j + Len("MESSAGE:" & vbCrLF)
                k = InStr(j, strMessage, " ")               
                If k > 0 Then
                    strCommand = UCase(Trim(Mid(strMessage, j, k - j)))
                    Select Case strCommand
                        
                        Case "OUT"
                            oRs.Fields("Status").Value = 1
                            oRs.Fields("AltitudeStatus").Value = -1
                            
                        Case "OFF"
                            oRs.Fields("Status").Value = 2
                            oRs.Fields("AltitudeStatus").Value = -1

                        '### Added v2.5 ###
                        Case "TNG"
                            oRs.Fields("Status").Value = 2
                        
                        Case "ON"
                            oRs.Fields("Status").Value = 3
                            oRs.Fields("AltitudeStatus").Value = -1
                        
                            '### Added v2.5 ###
                            oRs.Fields("CurrentWaypoint").Value = "####LANDED####"

                        Case "IN"
                            oRs.Fields("Status").Value = 4
                            oRs.Fields("AltitudeStatus").Value = -1
                        
                        Case "POS"
                            k = 0
                            k = InStr(j, strMessage, vbCrLf)
                            j = j + 4
                            If k > 0 Then
                                '### Added v2.5 ###
                                strWP = Trim(Mid(strMessage, j, k - j))
                                '### Changed v2.5 ###
                                oRs.Fields("Position").Value = strWP

                                '### Added v2.5 ###
                                m = InstrRev(strWP, "[")
                                If m > 0 Then
                                    n = InstrRev(strWP, "]")
                                    If n > m Then
                                        strWP = Mid(strWP, m + 1, n - m - 1)
                                        oRs.Fields("CurrentWaypoint").Value = UCase(strWP)
                                    End If
                                End If
                            End If
                            
                        Case "ALT"
                            k = 0
                            j = j + Len("ALT ")
                            k = InStr(j, strMessage, " ")
                            If k > 0 Then
                                oRs.Fields("Altitude").Value = Trim(Mid(strMessage, j, k - j))
                            End If

                            If InStr(1, strMessage, "DESC", 1) Then
                                oRs.Fields("AltitudeStatus").Value = 0
                            ElseIf InStr(1, strMessage, "LEVEL", 1) Then
                                oRs.Fields("AltitudeStatus").Value = 1
                            ElseIf InStr(1, strMessage, "CLIMB", 1) Then
                                oRs.Fields("AltitudeStatus").Value = 2
                            End If
                                                                                                                                            
                    End Select
                End If              
            End If
            
            j = 0
            k = 0
            j = InStr(1, strMessage, "/POS ", 1)
            If j > 0 Then
                j = j + Len("/POS ")
                k = InStr(j, strMessage, vbCrLf)
                If k > 0 Then
                    oRs.Fields("Position").Value = Trim(Mid(strMessage, j, k - j))
                End If
            End If

            j = 0
            k = 0
            j = InStr(1, strMessage, "/HDG ", 1)
            If j > 0 Then
                j = j + Len("/HDG ")
                k = InStr(j, strMessage, vbCrLf)
                If k > 0 Then
                    oRs.Fields("Heading").Value = Trim(Mid(strMessage, j, k - j))
                End If
            End If

            '### Added v2.7 ###
            j = 0
            k = 0
            j = InStr(1, strMessage, "/HDT ", 1)
            If j > 0 Then
                j = j + Len("/HDT ")
                k = InStr(j, strMessage, vbCrLf)
                If k > 0 Then
                    oRs.Fields("TrueHeading").Value = Trim(Mid(strMessage, j, k - j))
                End If
            End If

            j = 0
            k = 0
            j = InStr(1, strMessage, "/ALT ", 1)
            If j > 0 Then
                j = j + Len("/ALT ")
                k = InStr(j, strMessage, vbCrLf)
                If k > 0 Then
                    oRs.Fields("Altitude").Value = Trim(Mid(strMessage, j, k - j))
                End If
            End If

            j = 0
            k = 0
            j = InStr(1, strMessage, "/IAS ", 1)
            If j > 0 Then
                j = j + Len("/IAS ")
                k = InStr(j, strMessage, vbCrLf)
                If k > 0 Then
                    strCommand = Trim(Mid(strMessage, j, k - j))
                    k = 0
                    k = InStr(1, strCommand, " ")
                    If k > 0 Then
                        oRs.Fields("IAS").Value = Trim(Mid(strCommand, 1, k))
                    Else
                        oRs.Fields("IAS").Value = Trim(strCommand)
                    End If
                End If
            End If

            j = 0
            k = 0
            j = InStr(1, strMessage, "/TAS ", 1)
            If j > 0 Then
                j = j + Len("/TAS ")
                k = InStr(j, strMessage, vbCrLf)
                If k > 0 Then
                    strCommand = Trim(Mid(strMessage, j, k - j))
                    k = 0
                    k = InStr(1, strCommand, " ")
                    If k > 0 Then
                        oRs.Fields("TAS").Value = Trim(Mid(strCommand, 1, k))
                    Else
                        oRs.Fields("TAS").Value = Trim(strCommand)
                    End If
                End If
            End If
                
            j = 0
            k = 0
            j = InStr(1, strMessage, "/FOB ", 1)
            If j > 0 Then
                j = j + Len("/FOB ")
                k = InStr(j, strMessage, vbCrLf)
                If k > 0 Then
                    strCommand = Trim(Mid(strMessage, j, k - j))
                    k = 0
                    k = InStr(1, strCommand, " ")
                    If k > 0 Then
                        oRs.Fields("Fuel").Value = Trim(Mid(strCommand, 1, k))
                    Else
                        oRs.Fields("Fuel").Value = Trim(strCommand)
                    End If
                End If
            End If

            j = 0
            k = 0
            j = InStr(1, strMessage, "/WND ", 1)
            If j > 0 Then
                j = j + Len("/WND ")
                k = InStr(j, strMessage, vbCrLf)
                If k > 0 Then
                    strCommand = Trim(Mid(strMessage, j, k - j))
                    k = 0
                    k = InStr(1, strCommand, " ")
                    If k > 0 Then
                        oRs.Fields("Wind").Value = Trim(Mid(strCommand, 1, k))
                    Else
                        oRs.Fields("Wind").Value = Trim(strCommand)
                    End If
                End If
            End If

            j = 0
            k = 0
            j = InStr(1, strMessage, "/OAT ", 1)
            If j > 0 Then
                j = j + Len("/OAT ")
                k = InStr(j, strMessage, vbCrLf)
                If k > 0 Then
                    strCommand = Trim(Mid(strMessage, j, k - j))
                    k = 0
                    k = InStr(1, strCommand, " ")
                    If k > 0 Then
                        oRs.Fields("OAT").Value = CLng(Trim(Mid(strCommand, 1, k)))
                    Else
                        oRs.Fields("OAT").Value = CLng((strCommand))
                    End If
                End If
            End If
                        
            '### Added v2.0 ###
            j = 0
            k = 0
            j = InStr(1, strMessage, "/DST ", 1)
            If j > 0 Then
                j = j + Len("/DST ")
                k = InStr(j, strMessage, vbCrLf)
                If k > 0 Then
                    arData = Split(Trim(Mid(strMessage, j, k - j)), "-")
                    If Ubound(arData) >= 0 Then oRs.Fields("DistanceFlown").Value = CLng(Trim(arData(0)))
                    If Ubound(arData) >= 1 Then oRs.Fields("DistancePlanned").Value = CLng(Trim(arData(1)))
                End If
            End If
                                    
            oRs.Fields("LastMessage").Value = Now()
            oRs.Fields("Messages").Value = oRs.Fields("Messages").Value & strMessage
            oRs.Update
            
            Response.Write "1"
        Else
            Response.Write "0|Unknown Flight ID"
        End If

    '### Added v3.0 ###
    Case "UPDATEFLIGHTPLAN"
        Set oRs = Server.CreateObject("ADODB.Recordset")
        oRs.CursorLocation = 3 'adUseClient
        oRs.LockType = 3 'adLockOptimistic
        oRs.CursorType = 1 'adOpenKeyset
        Set oRs.ActiveConnection = oConn
        oRs.Open "SELECT * FROM LiveACARS WHERE IDFlight = '" & strValue & "'", , , , 1 'adCmdText

        If Not oRs.EOF Then
            arData = Split(strMessage, "|")
            If UBound(arData) < 6 Then
                Response.Write "0|Invalid flight plan data"
            Else
                oRs.Fields("FlightPlan").Value = arData(0)
                oRs.Fields("FPLatitudes").Value = arData(1)
                oRs.Fields("FPLongitudes").Value = arData(2)
                oRs.Fields("OriginAirport").Value = arData(3)
                oRs.Fields("DestinationAirport").Value = arData(4)
                oRs.Fields("DistancePlanned").Value = arData(5)
                oRs.Fields("CurrentWaypoint").Value = arData(6)
                oRs.Update
               
                Response.Write "1|"
            End If
        Else
            Response.Write "0|Unknown Flight ID"
        End If        
        
    Case "TEST"
        '### Changed v3.0 ###
        Set oRs = Server.CreateObject("ADODB.Recordset")
        oRs.CursorLocation = 3 'adUseClient
        oRs.LockType = 3 'adLockOptimistic
        oRs.CursorType = 1 'adOpenKeyset
        Set oRs.ActiveConnection = oConn
        oRs.Open "SELECT * FROM Pilots WHERE IDPilot = '" & strValue & "'", , , , 1 'adCmdText

        If Not oRs.EOF Then
            Response.Write "1|30"
        Else
            Response.Write "0|Unknown ID " & strValue
        End If

    Case Else
        Response.Write "0|Wrong Function"
        
End Select

If Not IsEmpty(oRs) Then
    If Not oRs Is Nothing Then
        If oRs.State = 1 Then oRs.Close
            Set oRs = Nothing
    End If
End If

If Not IsEmpty(oConn) Then
    If Not oConn Is Nothing Then
            If oConn.State = 1 Then oConn.Close
            Set oConn = Nothing
    End If
End If
%>