<% Option Explicit %>
<!-- #include file = "SQL.asp" -->
<%

'--HEADER--------------------------------------------------------------------------
'
'    Project   : Live ACARS Demo Web Service v3.1
'    Author    : Thomas Molitor
'    Company   : Thomas Molitor EDV Service
'    Copyright : Copyright  2002-2011 Thomas Molitor
'
'    Notes:
'
'
'
'--END-----------------------------------------------------------------------------

Dim strFunction
Dim strValue
Dim strMessage
Dim arData
Dim lngCount, i, j, k
Dim oConn, oRs
Dim strData
dim arVersion, arID
Dim bolV12AndHigher

'### Added v2.0 ###
Dim bolV20AndHigher

'### Added v2.5 ###
Dim strPlan

If Not Connect(oConn) Then
    Response.End
End If

'### Added 2.6 ###
'Delete not responding flight entries (LastMessage older than 30 minutes)
oConn.Execute "DELETE FROM LiveACARS WHERE LastMessage <= #" & DateAdd("n", -30, Now()) & "#"

bolV12AndHigher = False

'### Added v2.0 ###
bolV20AndHigher = False

strData = UCase(Request("DATA1"))
If Len(strData) <> 0 Then
    arID = Split(strData, "|")
    If UBound(arID) = 1 Then
        If arID(0) = "FLKEEPER" Then
            arVersion = Split(arID(1), ".")
            If UBound(arVersion) = 1 Then
                If arVersion(0) >= 1 and arVersion(1) >= 2 Then bolV12AndHigher = True

                '### Added v2.0 ###
                If arVersion(0) >= 2 and arVersion(1) >= 0 Then
                    bolV12AndHigher = True
                    bolV20AndHigher = True
                End If
            End If
        End If
    End If
End If

Set oRs = Server.CreateObject("ADODB.Recordset")
oRs.CursorLocation = 3 'adUseClient
oRs.LockType = 3 'adLockOptimistic
oRs.CursorType = 1 'adOpenKeyset
Set oRs.ActiveConnection = oConn

'### Changed v2.5 ###
oRs.Open "SELECT * FROM LiveACARS", , , , 1 'adCmdText

If Not oRs.EOF Then

    Do While Not oRs.EOF

        '### Changed v3.0 ###
        'IDFlight|IDPilot|Pilot|FlightCaption|Aircraft|OriginAirport|DestinationAirport|Latitude|Longitude|Altitude|Heading|IAS|TAS|ZFW|FOB|Status|FlightTime|BlockTime|Passenger|Cargo|Wind|OAT|FlightType|FlightPlan|DistanceFlown|DistancePlanned|TrueHeading|FPLatitudes|FPLongitudes
        '   0    |   1   |  2  |      3      |   4    |      5      |        6         |    7   |    8    |    9   |   10  | 11| 12| 13| 14|  15  |    16    |    17   |    18   |  19 | 20 | 21|    22    |    23    |     24      |      25       |     26    |     27    |      28

        strValue = strValue & oRs.Fields("IDFlight").Value & "|"
        strValue = strValue & oRs.Fields("IDPilot").Value & "|"
        strValue = strValue & oRs.Fields("PilotName").Value & "|"

        ' ### Changed v2.6 ###
        If Len(oRs.Fields("Airline").Value) <> 0 Then
            strValue = strValue & oRs.Fields("Airline").Value
            If Len(oRs.Fields("FlightNumber").Value) <> 0 Then
                strValue = strValue & " " & oRs.Fields("FlightNumber").Value
            End If
        ElseIf Len(oRs.Fields("FlightNumber").Value) <> 0 Then
            strValue = strValue & oRs.Fields("FlightNumber").Value
        Else
            strValue = strValue & oRs.Fields("PilotName").Value & " (" & oRs.Fields("IDPilot").Value & ")"
        End If
        strValue = strValue & "|"
        
        strValue = strValue & oRs.Fields("Aircraft").Value & "|"
        strValue = strValue & oRs.Fields("OriginAirport").Value & "|"
        strValue = strValue & oRs.Fields("DestinationAirport").Value & "|"

        arData = Split(oRs.Fields("Position").Value, " ")
        If UBound(arData) >= 3 Then
            strValue = strValue & arData(0) & " " & arData(1) &  "|" & arData(2) & " " & arData(3) &  "|"
        Else
            strValue = strValue & "||"
        End If

        If oRs.Fields("Altitude").Value <> -100000 Then
            strValue = strValue & oRs.Fields("Altitude").Value  & " ft|"
        Else
            strValue = strValue & ""  & "|"
        End If

        If oRs.Fields("Heading").Value <> -1 Then
            strValue = strValue & oRs.Fields("Heading").Value  & "|"
        Else
            strValue = strValue & ""  & "|"
        End If

        If oRs.Fields("IAS").Value <> -1 Then
            strValue = strValue & oRs.Fields("IAS").Value  & " kts|"
        Else
            strValue = strValue & ""  & "|"
        End If

        If bolV12AndHigher Then
            If oRs.Fields("TAS").Value <> -1 And oRs.Fields("Status").Value = 2 Then
                strValue = strValue & oRs.Fields("TAS").Value  & " kts|"
            Else
                strValue = strValue & ""  & "|"
            End If
        End If
        
        If oRs.Fields("ZFW").Value <> -1 Then
            strValue = strValue & oRs.Fields("ZFW").Value  & " lbs|"
        Else
            strValue = strValue & ""  & "|"
        End If

        If oRs.Fields("Fuel").Value <> -1 Then
            strValue = strValue & oRs.Fields("Fuel").Value  & " lbs|"
        Else
            strValue = strValue & ""  & "|"
        End If

        '### Entire Case Statement Changed v2.5 ###
        Select Case oRs.Fields("Status").Value

            Case 0
                strValue = strValue & "Boarding"

            Case 1
                strValue = strValue & "Taxiing"

            Case 2
                strValue = strValue & "Airborne"
                Select Case oRs.Fields("AltitudeStatus").Value
                    Case 0
                        strValue = strValue & " (Descending)"
        
                    Case 1
                        strValue = strValue & " (Level off)"
        
                    Case 2
                        strValue = strValue & " (Climbing)"
        
                End Select
        
            Case 3
                strValue = strValue & "Landed"

            Case 4
                strValue = strValue & "Parking"
                
        End Select
        If oRs.Fields("PauseMode").Value Then
            strValue = strValue & " [PAUSED]"
        End If
        strValue = strValue & "|"
        
        strValue = strValue & "" & "|"
        strValue = strValue & "" & "|"
        strValue = strValue & oRs.Fields("Passenger").Value & "|"
        strValue = strValue & oRs.Fields("Cargo").Value & "|"

        If Len(oRs.Fields("Wind").Value) < 5 Then
            strValue = strValue & "|"
        Else
            strValue = strValue & Left(oRs.Fields("Wind").Value, 3) & "/" & Mid(oRs.Fields("Wind").Value, 4) & "|"
        End If

        If oRs.Fields("OAT").Value <> -100000 Then
            strValue = strValue & oRs.Fields("OAT").Value & "|"
        Else
            strValue = strValue & "" & "|"
        End If

        strValue = strValue & oRs.Fields("FlightType").Value & "|"

        '### Changed v2.5 ###
        strPlan = oRs.Fields("FlightPlan").Value
        If Len(oRs.Fields("CurrentWaypoint").Value) > 0 Then
            strPlan = Replace(strPlan, oRs.Fields("CurrentWaypoint").Value, "[" & oRs.Fields("CurrentWaypoint").Value & "]")
        End If
        strValue = strValue & Replace(strPlan, "~", " - ")
        
        '### Changed v2.7 ###
        If bolV20AndHigher Then
            strValue = strValue & "|"
            If oRs.Fields("DistanceFlown").Value <> -1 Then
                strValue = strValue & oRs.Fields("DistanceFlown").Value  & "nm|"
            Else
                strValue = strValue & "0nm" & "|"
            End If
            If oRs.Fields("DistancePlanned").Value <> -1 Then
                strValue = strValue & oRs.Fields("DistancePlanned").Value  & "nm"
            Else
                strValue = strValue & "NA"
            End If

            '### Added v2.7 ###
            If oRs.Fields("TrueHeading").Value <> -1 Then
                strValue = strValue & "|" & oRs.Fields("TrueHeading").Value
            '### Added v3.0 ###
            Else
                strValue = strValue & "|"
            End If         
            
            '### Added v3.0 ###
            strValue = strValue & "|" & oRs.Fields("FPLatitudes").Value
            strValue = strValue & "|" & oRs.Fields("FPLongitudes").Value
        End If

        strValue = strValue & vbCrLf

        oRs.MoveNext
    Loop
End If

Response.Write strValue

If Not IsEmpty(oRs) Then
    If Not oRs Is Nothing Then
        If oRs.State = 1 Then oRs.Close
            Set oRs = Nothing
    End If
End If

If Not IsEmpty(oConn) Then
    If Not oConn Is Nothing Then
            If oConn.State = 1 Then oConn.Close
            Set oConn = Nothing
    End If
End If

%>