<% Option Explicit %>
<%
'--HEADER--------------------------------------------------------------------------
'
'    Project   : Live ACARS Demo PIREP Service v3.1
'    Author    : Thomas Molitor
'    Company   : Thomas Molitor EDV Service
'    Copyright : Copyright  2002-2011 Thomas Molitor
'
'    Notes:
'
'
'
'--END-----------------------------------------------------------------------------
%>

<!-- #include file = "SQL.asp" -->

<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<title>FS Flight Keeper - PIREP Script Demo</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"></head>
<meta http-equiv="Refresh" content="300">
<meta http-equiv="Expires" content="0">
<body>

<%

Function GetNewIDPIREP(ByVal FlightNumber)
    GetNewIDPIREP = Replace(FormatDatetime(Now(), 3), ":","") & FlightNumber
End Function

Dim strPIREP, strFlightData, strFlightPlan, strComment, strFlightCritique, strFlightMaps
Dim strIDPIREP, arData, arFlightMaps
Dim i, j
Dim oConn, oRs

    strPIREP = Trim(Request("DATA2"))
    If Len(strPIREP) = 0 Then
        Response.Write("Invalid PIREP data (no data transmitted).")
        Response.End()
    End If
    
    'Get Flight Data - <FLIGHTDATA>
    i = 0
    i = InStr(1, strPIREP, "<FLIGHTDATA>", vbTextCompare)
    If i = 0 Then
        Response.Write("Invalid PIREP data (tag <FLIGHTDATA> is missing).")
        Response.End()
    End If

    j = 0
    j = InStr(i + 1, strPIREP, "</FLIGHTDATA>", vbTextCompare)
    If j = 0 Then
        Response.Write("Invalid PIREP data (tag </FLIGHTDATA> is missing).")
        Response.End()
    End If
    
    strFlightData = Trim(Mid(strPIREP, i + Len("<FLIGHTDATA>"), j - (i + Len("<FLIGHTDATA>"))))
    strFlightData = Replace(strFlightData, vbLF, vbCR)
    strFlightData = Replace(strFlightData, vbCR, "")

    'Get Flight Plan - <FLIGHTPLAN>
    i = 0
    i = InStr(1, strPIREP, "<FLIGHTPLAN>", vbTextCompare)
    If i = 0 Then
        Response.Write("Invalid PIREP data (tag <FLIGHTPLAN> is missing).")
        Response.End()
    End If

    j = 0
    j = InStr(i + 1, strPIREP, "</FLIGHTPLAN>", vbTextCompare)
    If j = 0 Then
        Response.Write("Invalid PIREP data (tag </FLIGHTPLAN> is missing).")
        Response.End()
    End If
    
    strFlightPlan = Trim(Mid(strPIREP, i + Len("<FLIGHTPLAN>"), j - (i + Len("<FLIGHTPLAN>"))))

    'Get Comment - <COMMENT>
    i = 0
    i = InStr(1, strPIREP, "<COMMENT>", vbTextCompare)
    If i = 0 Then
        Response.Write("Invalid PIREP data (tag <COMMENT> is missing).")
        Response.End()
    End If

    j = 0
    j = InStr(i + 1, strPIREP, "</COMMENT>", vbTextCompare)
    If j = 0 Then
        Response.Write("Invalid PIREP data (tag </COMMENT> is missing).")
        Response.End()
    End If
    
    strComment = Trim(Mid(strPIREP, i + Len("<COMMENT>"), j - (i + Len("<COMMENT>"))))
    
    'Get Flight Critique - <FLIGHTCRITIQUE>
    i = 0
    i = InStr(1, strPIREP, "<FLIGHTCRITIQUE>", vbTextCompare)
    If i = 0 Then
        Response.Write("Invalid PIREP data (tag <FLIGHTCRITIQUE> is missing).")
        Response.End()
    End If

    j = 0
    j = InStr(i + 1, strPIREP, "</FLIGHTCRITIQUE>", vbTextCompare)
    If j = 0 Then
        Response.Write("Invalid PIREP data (tag </FLIGHTCRITIQUE> is missing).")
        Response.End()
    End If
    
    strFlightCritique = Trim(Mid(strPIREP, i + Len("<FLIGHTCRITIQUE>"), j - (i + Len("<FLIGHTCRITIQUE>"))))
    'strFlightCritique = Replace(strFlightCritique, "  ", "&nbsp;&nbsp;")
    
    'Get Flight Maps - <FLIGHTMAPS>
    i = 0
    i = InStr(1, strPIREP, "<FLIGHTMAPS>", vbTextCompare)
    If i = 0 Then
        Response.Write("Invalid PIREP data (tag <FLIGHTMAPS> is missing).")
        Response.End()
    End If

    j = 0
    j = InStr(i + 1, strPIREP, "</FLIGHTMAPS>", vbTextCompare)
    If j = 0 Then
        Response.Write("Invalid PIREP data (tag </FLIGHTMAPS> is missing).")
        Response.End()
    End If
    
    strFlightMaps = Trim(Mid(strPIREP, i + Len("<FLIGHTMAPS>"), j - (i + Len("<FLIGHTMAPS>"))))
    strFlightMaps = Replace(strFlightMaps, vbLF, vbCR)
    strFlightMaps = Replace(strFlightMaps, vbCR, "")
    
    'Analyze Flight Data
    arData = Split(strFlightData, "~")
    If UBound(arData) < 38 Then
        Response.Write("There are fields missing in the Flight Data (" & UBound(arData) + 1 &"/39).")
        Response.End()
    End If

    'Analyze Flight Maps Data
    arFlightMaps = Split(strFlightMaps, "~")
    If UBound(arData) < 5 Then
        Response.Write("There are fields missing in the Flight Maps Data (" & UBound(arData) + 1 &"/4).")
        Response.End()
    End If

    'Open Database
    If Not Connect(oConn) Then
        Response.Write("Database connection failed.")
        Response.End()
    End If
    
    'Create empty Recordset
    Set oRs = Server.CreateObject("ADODB.Recordset")
    oRs.CursorLocation = 3 'adUseClient
    oRs.LockType = 3 'adLockOptimistic
    oRs.CursorType = 1 'adOpenKeyset
    Set oRs.ActiveConnection = oConn
    oRs.Open "SELECT * FROM PIREP WHERE IDPIREP = ''", , , , 1 'adCmdText
    
    oRs.AddNew

    'PilotID|PilotName|AircraftTitle|AircraftType|AircraftTailNumber|AircraftAirline|FlightNumber|FlightLevel|FlightType
    '   0   |    1    |      2      |      3     |         4        |       5       |      6     |     7     |     8
    'Passenger|Cargo|ZFW|OriginICAO|OriginGate|OriginRunway|OriginTransitionAltitude|DestinationICAO
    '   9     | 10  | 11|    12    |    13    |     14     |           15           |       16
    'DestinationGate|DestinationRunway|DestinationTransitionAltitude|AlternateICAO|SID|STAR|FlightDistance|RouteDistance
    '       17      |        18       |              19             |      20     | 21| 22 |      23      |     24
    'OUTTime|OFFTime|ONTime|INTime|DayFlightTime|NightFlightTime|BlockTime|FlightTime|BlockFuel|FlightFuel|TOIAS|LAIAS|ONVS|FlightScore
    '  25   |  26   |  27  |  28  |     29      |       30      |    31   |     32   |    33   |    34    |  35 |  36 | 37 |    38

    '### Changed v2.6 ###
    If Len(Trim(arData(6))) <> 0 Then
        strIDPIREP = GetNewIDPIREP(Trim(arData(6)))
    Else
        strIDPIREP = GetNewIDPIREP(Trim(arData(0)))
    End If
    
    oRs.Fields("IDPIREP").Value = strIDPIREP
    oRs.Fields("CreatedOn").Value = Now()

    oRs.Fields("IDPilot").Value = Trim(arData(0))
    oRs.Fields("PilotName").Value = Trim(arData(1))
    oRs.Fields("AircraftTitle").Value = Trim(arData(2))
    oRs.Fields("AircraftType").Value = Trim(arData(3))
    oRs.Fields("Tailnumber").Value = Trim(arData(4))
    oRs.Fields("Airline").Value = Trim(arData(5))
    
    '### Changed v2.6 ###
    If Len(Trim(arData(6))) <> 0 Then
        oRs.Fields("FlightNumber").Value = Trim(arData(6))
    Else
        oRs.Fields("FlightNumber").Value = strIDPIREP
    End If
    
    oRs.Fields("FlightLevel").Value = Trim(arData(7))
    oRs.Fields("FlightType").Value = Trim(arData(8))
    oRs.Fields("Passenger").Value = Trim(arData(9))
    oRs.Fields("Cargo").Value = Trim(arData(10))
    oRs.Fields("ZFW").Value = Trim(arData(11))
    oRs.Fields("OriginAirport").Value = Trim(arData(12))
    oRs.Fields("OriginGate").Value = Trim(arData(13))
    oRs.Fields("OriginRunway").Value = Trim(arData(14))
    oRs.Fields("OriginTA").Value = Trim(arData(15))
    oRs.Fields("DestinationAirport").Value = Trim(arData(16))
    oRs.Fields("DestinationGate").Value = Trim(arData(17))
    oRs.Fields("DestinationRunway").Value = Trim(arData(18))
    oRs.Fields("DestinationTA").Value = Trim(arData(19))
    oRs.Fields("AlternateAirport").Value = Trim(arData(20))
    oRs.Fields("SID").Value = Trim(arData(21))
    oRs.Fields("STAR").Value = Trim(arData(22))
    oRs.Fields("DistanceFlight").Value = Trim(arData(23))
    oRs.Fields("DistanceRoute").Value = Trim(arData(24))
    oRs.Fields("OUTTime").Value = Trim(arData(25))
    oRs.Fields("OFFTime").Value = Trim(arData(26))
    oRs.Fields("ONTime").Value = Trim(arData(27))
    oRs.Fields("INTime").Value = Trim(arData(28))
    oRs.Fields("DayFlightTime").Value = Trim(arData(29))
    oRs.Fields("NightFlightTime").Value = Trim(arData(30))
    oRs.Fields("BlockTime").Value = Trim(arData(31))
    oRs.Fields("FlightTime").Value = Trim(arData(32))
    oRs.Fields("BlockFuel").Value = Trim(arData(33))
    oRs.Fields("FlightFuel").Value = Trim(arData(34))
    oRs.Fields("TakeoffIAS").Value = Trim(arData(35))
    oRs.Fields("LandingIAS").Value = Trim(arData(36))
    oRs.Fields("LandingVS").Value = Trim(arData(37))
    oRs.Fields("FlightScore").Value = Trim(arData(38))

    oRs.Fields("FlightMapJPG").Value = Trim(arFlightMaps(0))
    oRs.Fields("FlightMapWeatherJPG").Value = Trim(arFlightMaps(1))
    oRs.Fields("FlightMapTaxiOutJPG").Value = Trim(arFlightMaps(2))
    oRs.Fields("FlightMapTaxiInJPG").Value = Trim(arFlightMaps(3))
    oRs.Fields("FlightMapVerticalProfileJPG").Value = Trim(arFlightMaps(4))
    oRs.Fields("FlightMapLandingProfileJPG").Value = Trim(arFlightMaps(5))		

    oRs.Fields("FlightPlan").Value = strFlightPlan
    oRs.Fields("FlightCritique").Value = strFlightCritique
    oRs.Fields("Comment").Value = strComment
    
    oRs.Update
    Response.Write("PIREP successfully transmitted.<br><br>" & vbCrLF)
    Response.Write("Visit the <a href=""http://localhost/FSFK/PIREPDetails.asp?ID=" & strIDPIREP & """>PIREP Details</a> page to review your flight.")

    'Close Recordset and Database connection
    If Not IsEmpty(oRs) Then
        If Not oRs Is Nothing Then
            If oRs.State = 1 Then oRs.Close
                Set oRs = Nothing
        End If
    End If
    
    If Not IsEmpty(oConn) Then
        If Not oConn Is Nothing Then
                If oConn.State = 1 Then oConn.Close
                Set oConn = Nothing
        End If
    End If
    
    
%>
</body>
</html>
