CREATE DATABASE IF NOT EXISTS flkeeper;

USE flkeeper;

DROP TABLE IF EXISTS liveacars;
CREATE TABLE liveacars (
  IDFlight varchar(255) NOT NULL default '',
  IDPilot varchar(255) default NULL,
  PilotName varchar(255) default NULL,
  Status int(11) default NULL,
  Messages text,
  Aircraft varchar(255) default NULL,
  Airline varchar(255) default NULL,
  FlightNumber varchar(255) default NULL,
  FlightPlan text,
  FPLatitudes text,
  FPLongitudes text,
  Position varchar(255) default NULL,
  CurrentWaypoint varchar(255) default NULL,
  Heading int(11) default NULL,
  TrueHeading int(11) default NULL,
  Altitude int(11) default NULL,
  IAS int(11) default NULL,
  TAS int(11) default NULL,
  AltitudeStatus int(11) default NULL,
  LastMessage timestamp(14),
  Passenger varchar(255) default NULL,
  Cargo varchar(255) default NULL,
  Fuel int(11) default NULL,
  ZFW int(11) default NULL,
  OriginAirport varchar(255) default NULL,
  DestinationAirport varchar(255) default NULL,
  Wind varchar(255) default NULL,
  OAT int(11) default NULL,
  FlightType varchar(255) default NULL,
  PauseMode tinyint(1) default NULL,
  DistanceFlown int(11) default NULL,
  DistancePlanned int(11) default NULL,
  PRIMARY KEY  (IDFlight)
) TYPE=MyISAM;

